#include "stdafx.h"
#include "B25.h"

CB25::CB25(void)
{
	m_hLib=NULL;
	m_pDecorder=NULL;
	m_pDecorderEx=NULL;
	m_dwVer = 0;
}

CB25::~CB25(void)
{
	Close();
}

BOOL CB25::Open(char *lpszInitStr)
{
	if(IsOpen()) Close();
	m_hLib = LoadLibraryA(lpszInitStr);
	if(!m_hLib) return FALSE;

	PFGETB25VERSION *pfGetVer=(PFGETB25VERSION*)GetProcAddress(m_hLib,"GetB25Version");
	if(pfGetVer)
	{
		m_dwVer = pfGetVer();
	}
	PFCREATEB25DECORDER *pfDec=(PFCREATEB25DECORDER*)GetProcAddress(m_hLib,"CreateB25Decoder");
	if(!pfDec)
	{

	}
	PFCREATEB25DECORDEREX *pfDecEx=(PFCREATEB25DECORDEREX*)GetProcAddress(m_hLib,"CreateB25DecoderEx");
	if(!pfDecEx)
	{

	}

	if(!pfDec&&!pfDecEx)
	{
		Close();
		return FALSE;
	}

	// ExłD悷
	if(pfDecEx)
	{
		m_pDecorderEx = pfDecEx();
	} else {
		m_pDecorder = pfDec();
	}
	if(!m_pDecorder&&!m_pDecorderEx)
	{
		Close();
		return FALSE;
	}
	return TRUE;
}

void CB25::Close()
{
	if(!IsOpen()) return;
	if(m_pDecorder)
	{
		m_pDecorder->Release();
		m_pDecorder=NULL;
	}
	if(m_pDecorderEx)
	{
		m_pDecorderEx->Release();
		m_pDecorderEx=NULL;
	}
	if(m_hLib)
	{
		FreeLibrary(m_hLib);
		m_hLib=NULL;
	}
	m_dwVer = 0;
}

BOOL CB25::IsOpen()
{
	return (m_hLib && (m_pDecorder||m_pDecorderEx));
}

BOOL CB25::Initialize()
{
	if(!IsOpen()) return FALSE;
	if(m_pDecorderEx)
	{
		return m_pDecorderEx->Initialize();
	} else {
		return m_pDecorder->Initialize();
	}
}

BOOL CB25::Reset()
{
	if(!IsOpen()) return FALSE;
	if(m_pDecorderEx)
	{
		return m_pDecorderEx->Reset();
	} else {
		return m_pDecorder->Reset();
	}
}

BOOL CB25::IsExtendAPI()
{
	if(!IsOpen()) return FALSE;
	return m_pDecorderEx ? TRUE : FALSE;
}

// gc[̒̐l Decord() ݊B ̕@ł put()̃G[ołȂ
DWORD CB25::DataPutAndGet(BYTE *pSrcBuf, DWORD dwSrcSize, BYTE **ppDstBuf, DWORD *pdwDstSize)
{
	if(!IsOpen()) return FALSE;
	if(m_pDecorderEx)
	{
		DWORD dwRet = m_pDecorderEx->Decode(pSrcBuf,dwSrcSize,ppDstBuf,pdwDstSize); 
		return dwRet;
	} else {
		BOOL bRet = m_pDecorder->Decode(pSrcBuf,dwSrcSize,ppDstBuf,pdwDstSize);
		return bRet ? B25_DECORD_SUCCESS : B25_DECORD_FAILED;
	}
}

// Marumoput()݊ B25Decorder.dllɂ͎ĂȂ
BOOL CB25::DataPut(BYTE *pSrcBuf, DWORD dwSrcSize)
{
	if(!IsOpen()) return FALSE;
	return FALSE;
}

// Marumoget()݊ B25Decorder.dllɂ͎ĂȂ
BOOL CB25::DataGet(BYTE **ppDstBuf, DWORD *pdwDstSize)
{
	if(!IsOpen()) return FALSE;
	return FALSE;
}

// gc[̒̐l Flush() ݊B
BOOL CB25::DataFlush(BYTE **ppDstBuf, DWORD *pdwDstSize)
{
	if(!IsOpen()) return FALSE;
	if(m_pDecorderEx)
	{
		return m_pDecorderEx->Flush(ppDstBuf,pdwDstSize);
	} else {
		return m_pDecorder->Flush(ppDstBuf,pdwDstSize);
	}
}

// o[W擾
BOOL CB25::Ext_GetB25Version(BYTE *pbyMajor,BYTE *pbyMinor,BYTE *pbyBuild)
{
	if(!IsOpen()) return FALSE;
	if(pbyMajor) *pbyMajor = (BYTE)((m_dwVer & 0xFF0000) >> 16);
	if(pbyMinor) *pbyMinor = (BYTE)((m_dwVer & 0x00FF00) >> 8);
	if(pbyBuild) *pbyBuild = (BYTE)((m_dwVer & 0x0000FF));
	return TRUE;
}

// EMM悤ɂ(gAPI)
BOOL CB25::Ext_ProcEmm(BOOL bFlag)
{
	if(!IsOpen()) return FALSE;
	if(!IsExtendAPI()) return FALSE;
	return m_pDecorderEx->SetOpeion(B25_OPTION_EMM,bFlag);
}