#include "StdAfx.h"
#include "Capusb_Main.h"

void CCapUSB_Main::DTVRecieveCallback(BYTE *pRecvData,DWORD dwRecvSize,unsigned __int64 ui64TotalRecvSize,LPVOID lpContext)
{
	static DWORD dwBeforeDraw=0;
	static DWORD dwBeforeXferCalc=0;
	static unsigned __int64 ui64BeforeTotalRecv=0;

	CCapUSB_Main *pThis=(CCapUSB_Main*)lpContext;
	if(dwRecvSize>0)
	{
		DWORD dwPutSize=pThis->m_pStreamBuf->Put(pRecvData,dwRecvSize);
		if(dwPutSize!=dwRecvSize)
		{
			// Mobt@s
			pThis->m_stStreamInfo.dwRecieveBufferOverflow++;
			DEBUG_BREAK();
			pThis->m_pStreamBuf->Clear();
		}
	}
	// ]xvZ	
	DWORD dwTime=GetTickCount();
	if(dwTime-dwBeforeXferCalc>CALCTIME_XFER_SPEED)
	{
		if(ui64TotalRecvSize>ui64BeforeTotalRecv)
		{
			pThis->m_stStreamInfo.dSpeed=(double)ui64TotalRecvSize-ui64BeforeTotalRecv;
			pThis->m_stStreamInfo.dSpeed=pThis->m_stStreamInfo.dSpeed*( 1000.0/(dwTime-dwBeforeXferCalc) );
		} else {
			pThis->m_stStreamInfo.dSpeed=0;
		}

		dwBeforeXferCalc=dwTime;
		ui64BeforeTotalRecv=ui64TotalRecvSize;
	}	
	// CXbhWM_USERoRŕ\
	if(dwTime-dwBeforeDraw>REDRAWTIME_XFER_RESULT)
	{
		PostMessage(pThis->m_hWnd,WM_USER,1,NULL);
		dwBeforeDraw=dwTime;
	}
}

// Xg[
DWORD CCapUSB_Main::StreamProcThreadProc(struct StreamProcThreadParam *pStreamProc)
{
	m_pTsStream=new CTsStream(pStreamProc->pB25);

	try
	{
		m_wTsStreamOutput_Schedule = TS_OUTPUT_DEFAULT + 1;
		m_pTsStream->AddOutput(m_wTsStreamOutput_Schedule);

		if(m_pScheduleRec)
		{
			m_pScheduleRec->SetFilterCallback(OnScheduleSetFilter,this);
			m_pScheduleRec->EpgRequestCallback(OnScheduleEpgRequestByID,OnFilterWndEpgRequest,this);
		}
		if(m_pFilterWnd)
		{
			m_pFilterWnd->Set_GetServiceNameCallback(OnGetServiceName,this);
			m_pFilterWnd->SetScheduleByTimeCallback(OnFilterWndSetSchduleByTime,this);
			m_pFilterWnd->SetScheduleByEventIDCallback(OnFilterWndSetSchduleByEventID,this);
			m_pFilterWnd->SetOutputDataCallback(OnFilterWndOutputData,this);
#ifdef _DEBUG
			m_pFilterWnd->SetDebugDumpEpgRequestCallback(OnDebugDumpEpgList,this);
#endif
			m_pFilterWnd->SetEpgEnable(m_stOpt.bProcEPG);
			m_pFilterWnd->SetDataEnable(m_stOpt.bProcData);
		}

		m_pTsStream->SetDecodePSI(m_stOpt.bDecodePSI);
		m_pTsStream->SetDataProc(m_stOpt.bProcData);
		m_pTsStream->SetEpgProc(m_stOpt.bProcEPG);
		m_pTsStream->SetNullPacketNoReject(m_stOpt.bNoRejectNullPacket);
		m_pTsStream->SetCallbackFunc(TsCallback,this);
		while(WaitForSingleObject(m_stStreamProc.hExitEvent,0)!=WAIT_OBJECT_0)
		{
			BYTE buf[ASYNC_XFER_SIZE];
			DWORD len;
			while(m_pStreamBuf->GetDataSize()>=ASYNC_XFER_SIZE)
			{
				len=m_pStreamBuf->Get(buf,ASYNC_XFER_SIZE);
				if(len>0)
				{
					m_pTsStream->OnTsStream(buf,len,&m_stStreamInfo);
				}
			}
			// B25 Flags
			m_stStreamInfo.bB25Proc = pStreamProc->pB25 ? TRUE : FALSE;
			if(m_stStreamInfo.bB25Proc)
			{
				m_stStreamInfo.bB25Extend = pStreamProc->pB25->IsExtendAPI();
                pStreamProc->pB25->Ext_GetB25Version(&m_stStreamInfo.stB25Ver.byMajor,&m_stStreamInfo.stB25Ver.byMinor,&m_stStreamInfo.stB25Ver.byBuild);
			}
			// Xbhҋ@
			Sleep(1);
		}
	}
	catch(int err_code)
	{
		CATCH_INT_ERROR_CODE(err_code);
	}
	m_pTsStream->OnTsStreamTerminate(&m_stStreamInfo);
	delete m_pTsStream;
	m_wTsStreamOutput_Schedule=0;
	m_pTsStream=NULL;
	if(pStreamProc->pB25) delete pStreamProc->pB25;
	delete pStreamProc;
	ExitThread(1);
	return 0;
}

// TSXg[̃R[obN
void CCapUSB_Main::TsCallback(UINT uType,WORD wStreamID,LPVOID pData,DWORD dwVal,LPVOID lpContext)
{
	CCapUSB_Main *pThis=(CCapUSB_Main*)lpContext;
		
	switch(uType)
	{
	case TSENG_CALLBACK_PACKET:
		{
			WORD wNo=wStreamID;
			if(wNo==TS_OUTPUT_DEFAULT)
			{
				if(pThis->m_pFileRecord)
				{
					pThis->m_pFileRecord->Write(pData,dwVal);
				}
				if(pThis->m_pNetworkSend)
				{
					pThis->m_pNetworkSend->Send(pData,dwVal);
				}
			}
			if(wNo==pThis->m_wTsStreamOutput_Schedule)
			{
				if(pThis->m_pScheduleRec)
				{
					pThis->m_pScheduleRec->PutStream((BYTE*)pData,dwVal);
				}
			}
		}
		break;
	case TSENG_CALLBACK_TIME_RECIEVE:
	case TSENG_CALLBACK_STREAM_RESET:
	case TSENG_CALLBACK_PAT_RECIEVE:
	case TSENG_CALLBACK_PMT_RECIEVE:
	case TSENG_CALLBACK_NIT_RECIEVE:
	case TSENG_CALLBACK_SATELLITE_INFO:
	case TSENG_CALLBACK_SDT_RECIEVE:
	case TSENG_CALLBACK_EIT_PF_RECIEVE:
	case TSENG_CALLBACK_EIT_SCHEDULE_RECIEVE:
		// UIɊ֘ÂÃt@Cւ̋Lq͌TSf[^Xg[̂
		pThis->TsCallbackUI(uType,wStreamID,pData,dwVal,lpContext);
		break;
	}
}

// T[rX擾
BOOL CCapUSB_Main::OnGetServiceName(WORD wServiceID,char *lpszBuf,int iBufLen,LPVOID lpContext)
{
	CCapUSB_Main *pThis = static_cast<CCapUSB_Main*>(lpContext);
	if(pThis->m_pTsStream)
	{
		return pThis->m_pTsStream->GetServiceName(wServiceID,lpszBuf,iBufLen);
	}
	return FALSE;
}

// tB^w(ŵ)
void CCapUSB_Main::OnSetFilter(WORD *pwDenyServiceList,int iDenyServiceNum,WORD *pwDenyPidList,int iDenyPidNum,LPVOID lpContext)
{
	CCapUSB_Main *pThis = static_cast<CCapUSB_Main*>(lpContext);
	if(pThis->m_pTsStream)
	{		
		if(pwDenyServiceList==NULL && iDenyServiceNum==0 && pwDenyPidList==NULL && iDenyPidNum==0)
		{
			pThis->m_pTsStream->ClearAllFilter(TS_OUTPUT_DEFAULT);
		} else {
			pThis->m_pTsStream->SetFilter(TS_OUTPUT_DEFAULT,TRUE,pwDenyServiceList,iDenyServiceNum,TRUE,pwDenyPidList,iDenyPidNum);
		}
	}
}

// \^̃tB^w(T[rX̗L/w)
void CCapUSB_Main::OnScheduleSetFilter(BOOL bServiceDenyFlg,WORD *pwSelectService,int iSelectServiceNum,WORD *pwDenyPidList,int iDenyPidNum,LPVOID lpContext)
{
	CCapUSB_Main *pThis = static_cast<CCapUSB_Main*>(lpContext);
	if(pThis->m_pTsStream)
	{
		if(pwSelectService==NULL && iSelectServiceNum==0 && pwDenyPidList==NULL && iDenyPidNum==0)
		{
			pThis->m_pTsStream->ClearAllFilter(pThis->m_wTsStreamOutput_Schedule);
		} else {
			pThis->m_pTsStream->SetFilter(pThis->m_wTsStreamOutput_Schedule,bServiceDenyFlg,pwSelectService,iSelectServiceNum,TRUE,pwDenyPidList,iDenyPidNum);
		}
	}
}

// EPGf[^₢킹
BOOL CCapUSB_Main::OnFilterWndEpgRequest(WORD wServiceID,DateTime &stSearchTime,struct TSEPG_PROGRAM *pEpgData,BOOL bDeleteFlg,LPVOID lpContext)
{
	CCapUSB_Main *pThis = static_cast<CCapUSB_Main*>(lpContext);
	if(!pThis->m_pTsStream) return FALSE;

	CTsEPGMgr *pEpg=pThis->m_pTsStream->GetEpgMgr();
	if(pEpg)
	{
		// DeleteMode = FALSE ɋύX(폜͕ʓrs悤ɉ)
		struct TSEPG_PROGRAM *pstFind = pEpg->FindEpgDataByTime(wServiceID,stSearchTime,FALSE);
		if(pstFind)
		{
			*pEpgData = *pstFind;
			pEpg->FreeEpgDataMemory(pstFind,1);
			return TRUE;
		}
	}
	return FALSE;
}

// ^\EBhÊdoff[^擾NGXg
BOOL CCapUSB_Main::OnScheduleEpgRequestByID(WORD wNetworkID,WORD wStreamID,WORD wServiceID,WORD wEventID,struct TSEPG_PROGRAM *pEpgData,LPVOID lpContext)
{
	CCapUSB_Main *pThis = static_cast<CCapUSB_Main*>(lpContext);
	if(!pThis->m_pTsStream) return FALSE;

	CTsEPGMgr *pEpg=pThis->m_pTsStream->GetEpgMgr();
	if(pEpg)
	{
		struct TSEPG_PROGRAM *pstFind = pEpg->FindEpgDataByEventID(wNetworkID,wStreamID,wServiceID,wEventID);
		if(pstFind)
		{
			*pEpgData = *pstFind;
			pEpg->FreeEpgDataMemory(pstFind,1);
			return TRUE;
		}
	}
	return FALSE;
}

// FilterWindow̎Ԏw^\v
BOOL CCapUSB_Main::OnFilterWndSetSchduleByTime(WORD wServiceID,DateTime &stStartTime,DWORD dwRecTime,char *lpszName,LPVOID lpContext)
{
	CCapUSB_Main *pThis = static_cast<CCapUSB_Main*>(lpContext);
	CScheduleRec *pScheduleRec=pThis->m_pScheduleRec;
	if(!pScheduleRec) return FALSE;
	int iCurrentChannel=-1;
	if(pThis->m_pDTV->GetExtFunction() & DTV_EXTFUNC_CHSEL)
	{
		iCurrentChannel=pThis->m_pDTV->GetChannel();
	}
	pScheduleRec->PutScheduleByTime(wServiceID,stStartTime,dwRecTime,lpszName,iCurrentChannel);
	return TRUE;
}

// FilterWindow̃Cxgw^\v
BOOL CCapUSB_Main::OnFilterWndSetSchduleByEventID(WORD wNetworkID,WORD wStreamID,WORD wServiceID,WORD wEventID,char *lpszName,LPVOID lpContext)
{
	CCapUSB_Main *pThis = static_cast<CCapUSB_Main*>(lpContext);
	CScheduleRec *pScheduleRec=pThis->m_pScheduleRec;
	if(!pScheduleRec) return FALSE;
	int iCurrentChannel=-1;
	if(pThis->m_pDTV->GetExtFunction() & DTV_EXTFUNC_CHSEL)
	{
		iCurrentChannel=pThis->m_pDTV->GetChannel();
	}
	pScheduleRec->PutScheduleByEventID(wNetworkID,wStreamID,wServiceID,wEventID,lpszName,iCurrentChannel);
	return TRUE;
}

// f[^o͂
BOOL CCapUSB_Main::OnFilterWndOutputData(char *lpszDir,WORD wPID,LPVOID lpContext)
{
	CCapUSB_Main *pThis = static_cast<CCapUSB_Main*>(lpContext);
	if(!pThis->m_pTsStream) return FALSE;
	return pThis->m_pTsStream->OutputDataContent(lpszDir,wPID);
}

#ifdef _DEBUG
// fobOpɂdoff[^eLXgɏo
void CCapUSB_Main::OnDebugDumpEpgList(WORD wServiceID,char *lpszOutputPath,LPVOID lpContext)
{
	CCapUSB_Main *pThis = static_cast<CCapUSB_Main*>(lpContext);
	if(!pThis->m_pTsStream) return;
	CTsEPGMgr *pEpg=pThis->m_pTsStream->GetEpgMgr();

	pEpg->DebugDump(wServiceID,lpszOutputPath);
}
#endif
